#include <stdlib.h>
#include <stdio.h>

#include "figbuild.h"
#include "aux.h"

static char rcsid[]="$Header: /home/apian/r/gen/figbuild/RCS/aux.c,v 1.7 2002/03/03 23:37:06 apian Exp apian $";

static	v_segments	*fvs=NULL;	/* first v_segs */
static	v_segments	*cvs=NULL;	/* current v_segs */

/*-----------------------------------------------------------------------------*/
char *fig_colorname( int c )		/* convert xfig color int to name */
{					/* directly from the xfig3.2 format spec*/
	char *s;

	switch(c) {
	  case(-1): s="Default";break;
	  case(0): s="Black";break;
	  case(1): s="Blue";break;
	  case(2): s="Green";break;
	  case(3): s="Cyan";break;
	  case(4): s="Red";break;
	  case(5): s="Magenta";break;
	  case(6): s="Yellow";break;
	  case(7): s="White";break;
	  case(8): s="Blue4";break;
	  case(9): s="Blue3";break;
	  case(10):s="Blue2";break;
	  case(11):s="LtBlue";break;
	  case(12):s="Green4";break;
	  case(13):s="Green3";break;
	  case(14):s="Green2";break;
	  case(15):s="Cyan4";break;
	  case(16):s="Cyan3";break;
	  case(17):s="Cyan2";break;
	  case(18):s="Red4";break;
	  case(19):s="Red3";break;
	  case(20):s="Red2";break;
	  case(21):s="Magenta4";break;
	  case(22):s="Magenta3";break;
	  case(23):s="Magenta2";break;
	  case(24):s="Brown4";break;
	  case(25):s="Brown3";break;
	  case(26):s="Brown2";break;
	  case(27):s="Pink4";break;
	  case(28):s="Pink3";break;
	  case(29):s="Pink2";break;
	  case(30):s="Pink";break;
	  case(31):s="Gold";break;
	  default: s="Default";
		fprintf(stderr,"colorname: can't gork colornumber %d, using \"Default\"\n",c);
	}
	return(s);
}
/*-----------------------------------------------------------------------------*/
char *fig_linestylename( int t )	/* convert xfig linestyle to name */
{					/* directly from the xfig3.2 format spec*/
	char *s;
	switch(t) {
	  case(-1): s="Default";break;
	  case(0): s="Solid";break;
	  case(1): s="Dashed";break;
	  case(2): s="Dotted";break;
	  case(3): s="Dash-Dot";break;
	  case(4): s="Dash-Dot-Dot";break;
	  case(5): s="Dash-Dot-Dot-Dot";break;
	  default: s="Default";
		fprintf(stderr,"colorname: can't gork linestylename %d, using \"Default\"\n",t);
	}
	return(s);
}
/*-----------------------------------------------------------------------------*/
void panic( char *s )
{
	fprintf(stderr,"%s - panic+exit\n",s);
	exit(2);
}

/*-----------------------------------------------------------------------------*/
void *tmalloc( size_t t ) 
{
	register void *p;
	if( !(p=malloc(t) ) ) {
	  panic("tmalloc failed\n");
	}
	return(p);
}
/*-----------------------------------------------------------------------------*/

v_segments *v_segs_new( )
{
	register v_segments *vs;
	vs= (v_segments *) tmalloc(sizeof(v_segments));
	vs->name= NULL;
	vs->next= NULL;
	if( !fvs ) {
	  fvs=cvs=vs;
	}else{
	  cvs->next=vs;
	  cvs=vs;
	}
	return(vs);
}

/*-----------------------------------------------------------------------------*/
v_segments *v_segs_lookup( char *name )
{
	register v_segments *vs=fvs;
	if( !vs ) return (NULL);
	do {
	  if( !strcmp( vs->name, name ) ) return(vs);
	  vs= vs->next;
	} while( vs );
	return( NULL );
}

/*-----------------------------------------------------------------------------*/

int v_segs_dump( v_segments *vs )
{
	register int i;

	fprintf(stderr,"v_segs_dump: \"%s\": extr=%d %d levels, gnd=%g, floormat=%s, ceilmat=%s\n",
		vs->name, vs->ex?1:0, vs->max, vs->gnd, vs->floormat, vs->ceilmat );
	if( !vs->ex ) {
	  for( i=0; i<vs->max; ++i ) {
	    fprintf(stderr,"\tlevel %d: name=%s height=%g\n",
		i, vs->segs[i].name, vs->segs[i].height );
	  }
	}
}

/*-----------------------------------------------------------------------------*/
h_segment *h_seg_new( )
{
	register h_segment *hs;
	hs= (h_segment *) tmalloc(sizeof(h_segment));
	return( hs );
}

/*-----------------------------------------------------------------------------*/
int h_seg_orientation( h_segment *hs )
{
	register int i;
	register float *x, *y, z=0;

	if( hs->npoints < 2 ) return(0);

	x= hs->x;
	y= hs->y;
	for( i=0; i< (hs->npoints-1); ++i ) {
	  z += x[i]*y[i+1] - x[i+1]*y[i] ;
	}

	return( z>0 );
}

/*-----------------------------------------------------------------------------*/
