/* $Header: /disc/apian/radiance/gen/figbuild/RCS/figbuild.h,v 1.4 1999/07/20 21:20:02 apian Exp apian $ */

typedef struct {		/* one vertical element of a wall */
	float	height;		/* height of upper edge of seqment */
	float	tilt;		/* this edge is displaced toward the outside */
	char *name;		/* material name */
	} v_segment;

#define	EXTRUSION_CYL		1
#define	EXTRUSION_BOX		2
#define	EXTRUSION_TRI		3

/*
	vertical segments,
	data we get from lex/yacc file
*/

#define	VSEG_MAX	30
#define	STRING_MAX	128

typedef struct {
	int	mode;	/* EXTRUSION: whether line defines extrusion */
	char	mat[STRING_MAX];
	float	scale_h, scale_v;
	} extrusion_data;

typedef struct v_Segments {
	struct v_Segments	*next;
	char		*name;	/* segment name */
	v_segment	segs[VSEG_MAX];
	int		max;	/* number of vertical segments in here */
	float		gnd;	/* ground level, default = 0.0 */
	extrusion_data *ex;
	int	roof_mode;	/* =0 for flat roof */
	int	filled;
	char	floormat[STRING_MAX], ceilmat[STRING_MAX];
	} v_segments;

#define	HSEG_TYPE_POLYGON	1
#define	HSEG_TYPE_CIRCLE	2

/*
	horizontal segment,
	data we get from fig file
*/
typedef struct {
	int type ;
	int linestyle, joinstyle, capstyle ;
	float thickness ;
	int filled ;
	int npoints ;
	float *x, *y;
	v_segments *vs;
	} h_segment;



int h_seg_orientation( h_segment * );

