%{

#define Float   double
#include "y.tab.h"

#include <stdio.h>
#include <stdlib.h>
extern char *strsave();
%}
alpha	[a-zA-Z]
special	[\.\_-]
digit	[0-9]
exp	[Ee][-+]?{digit}+
string	{alpha}({alpha}|{digit}|{special})*
filename "/"?"/"?(("."|".."|{string})"/")*{string}
%p 9400
%e 1500
%n 600
%%
[ \t\n]			;
"/*"			skipcomments();
"#"			skipcomments2();
"quote on"		skipquote();

"{"		return tDEFSEG;
defseg		return tDEFSEG;
tilt		return tTILT;
endseg		return tENDSEG;
"}"		return tENDSEG;
floormat	return tFLOORMAT;
ceilmat		return tCEILMAT;
ground		return tGROUND;
fill		return tFILL;
nofill		return tNOFILL;
2dscale		return t2DSCALE;
extrude		return tEXTRUDE;
box		return tBOX;
cyl		return tCYL;
origin		return tORIGIN;

{digit}+ |
{digit}+"."{digit}*({exp})? |
{digit}*"."{digit}+({exp})? |
{digit}+{exp}		{yylval.d = atof(yytext); return tFLOAT;}
{string}		{yylval.c = strsave(yytext); return tSTRING;}
.			return yytext[0];

%%
yywrap() {return 1;}
/*
 * Skip over comments.
 */
skipcomments()
{
	char c;

	while (1) {
		while (input() != '*')
			;
		if ((c = input()) == '/' || c==EOF)
			return;
		unput(c);
	}
}
/*
 * Skip over comments.
 */
skipcomments2()
{
	char c;
	while (1) {
	  if ((c = input()) == '\n' || c==EOF) return;
	}
}

/*
 * copy quotes to stdout
*/
skipquote()
{
	char c;
	char qo[]="quote off";
	char t[64];
	register int i=0,l;
	register char sc;

	l= strlen(qo);
	sc = t[0] = qo[0];
	t[l] = 0;
	while (1) {
	  while( (c = input()) != sc ) putc(c,stdout);	/* search and copy until 'q' */
	  for(i=1;i<l;++i) t[i]=input();		/* read keyword */
	  if( !strcmp(t,qo) ) return;
	  printf("%s",t);
	}
}

#ifdef STRSAVE_NEEDED
/*
 * Allocate space for a string, copy string into space.
 * stolen from rayshade libcommon memory.c
 */
char *
strsave(s)
char *s;
{
        char *tmp;

        if (s == (char *)NULL)
                return (char *)NULL;

        tmp = (char *)malloc((unsigned)strlen(s) + 1);
        (void)strcpy(tmp, s);
        return tmp;
}
#endif


